#include "bsp.h"

unsigned volatile int tics = 0;
unsigned volatile int msec = 0;
unsigned volatile int sec = 0;

void __attribute__((interrupt))
timer_ra_handler ()
{
  unsigned char c;
  tics ++;
  if (++msec == 1000)
    {
      sec ++;
      msec = 0;

    }
#ifdef MORE_LEDS
  c = led_gamma[msec/4] >> 8;
  trbpr = c;
  trbsc = ~c;
#endif
}

static void __attribute__((constructor))
timer_A_initialize ()
{
  tracr = 0;
  traioc = 0;
  tramr = 0;
#if CLOCK_HZ == 18432000
  /* 144 * 128 = 18432 */
  trapre = 144 - 1;
  tra = 128 - 1;
#else
#ifdef CLOCK_125KHz
  trapre = 0;
  tra = 124;
#else
  trapre = (CLOCK_HZ / 100000) - 1;
  tra = 100-1;
#endif
#endif
  traic = 5;
  tstart_tracr = 1;

}

#ifdef MORE_LEDS
void
start_timer_b ()
{
  trbmr = 1;
  trbpre = 1;
  trbrcsr = 0;
  tstart_trbcr = 1;
}
#endif

int
wait_ms (int ms)
{
  int now = tics;
  while ((int)(tics - now) < ms)
    ;
}

int
wait_sec ()
{
  unsigned now = sec;
  while (sec == now)
    ;
}
